// Sensor code


#include <Wire.h>


#define Addr 0x78 //  Die I2C Addresse 0x78(120)
#define DigoutPmax 29491
#define DigoutPmin 3277
#define Pmax 344.7
#define Pmin 0
#define DigoutTmax 29491
#define DigoutTmin 3277
#define Tmax 85
#define Tmin -25
#define Fensterbreite 50

const long Abtastfrequenz = 15624;
//unsigned long VergangeZeit = 0;
//unsigned long AktuelleZeit = 0;
unsigned long int data[4];
float Pm = 0;
long i = 1;
float GetWert;



float AMSSensor()
{
 int i = 1; 
  
  data[0] = 0;
  data[1] = 0;
  data[2] = 0;
  data[3] = 0;  
  

    while(i<= Fensterbreite)
     {
       
        Wire.requestFrom(Addr, 4);
      
         if (Wire.available() == 4)
       {
          //Serial.print(i);
          //Serial.println(" Druchlauf der WHILE-SCHLEIFE ");
          data[0] =  data[0] + Wire.read();
          //Serial.print(data[0]);
          //Serial.println(" Akuteller Druckwert  ");
          //Serial.println(" = Druckwert 1");
          data[1] = data[1] + Wire.read();
          //Serial.print(data[1]);
          //Serial.println(" = Druckwert 2");
          data[2] = data[2] + Wire.read();
          //Serial.print(data[2]);
          //Serial.println(" = Temperaturwert 1");
          data[3] = data[3] + Wire.read();
          //Serial.print(data[3]);
          //Serial.println(" = Temperaturwert 2");
       }
       i ++;
     }
     
    i = 1;
    //Serial.print(data[0]);
    //Serial.println(" Akuteller Druckwert nach der WHILE-SCHLEIFE");
    data[0] = data[0]/Fensterbreite; 
    //Serial.print(data[0]);
    //Serial.println(" Akuteller Druckwert nach der Mittlung (Dividert druch Fensterbreite)");
    data[1] = data[1]/Fensterbreite;
    data[2] = data[2]/Fensterbreite;
    data[3] = data[3]/Fensterbreite;    
  
    
      // Berechung      
      float SensP = ((DigoutPmax -DigoutPmin) / (Pmax -Pmin));
      float DigoutP = ((data[0] * 256) + data[1]); 
      float P = ((DigoutP - DigoutPmin) / SensP) + Pmin;
      GetWert = P;
      
      float SensT = ((DigoutTmax -DigoutTmin) / (Tmax - Tmin));
      float DigoutT = ((data[2] * 256) + data[3]);
      float T = ((DigoutT - DigoutTmin) / SensT) + Tmin;  
        
       //Auusgabe
       //Serial.print("Druck in mbar : ");
       //Serial.println(P);
      
       //Serial.print("Temperature in Grad Celsius : ");
       //Serial.println( T);
       //Serial.print(millis()); Serial.println("  Millisekunden sind vergangen");
        
   return P;   
}

float GetAMSSensor()
{
  return GetWert;
}




