// stepper.hs

#ifndef STEPPER_H
#define STEPPER_H
#include <arduino.h>
#include "defines.h"

class StepperV1
{
private:
  // Membervariablen für die Treiber-Pins
  int Step_Pin;
  int Dir_Pin;
  int Enable_Pin;
//  bool Enable;

public:
  // Konstruktoren mit Output-Pins als Parameter
  StepperV1(int Step_Pin, int Dir_Pin, int Enable_Pin);
  StepperV1(int Step_Pin, int Dir_Pin, int Enable_Pin, int Speed, bool Direction);
  
  // Methoden
  void SetEnable(bool Enable); // Setzen auf Sperren oder Freigabe am Treiber  
  void SetDirection(bool Direction); // Setzen der Drehrichtung
  void SetStepPin(bool EN);
};
#endif
